## pam-wrapper 1.0.2

=== CMakeLists.txt ===
project(pam_wrapper C)

# Required cmake version
cmake_minimum_required(VERSION 2.8.0)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

set(APPLICATION_VERSION_MAJOR "1")
set(APPLICATION_VERSION_MINOR "0")
set(APPLICATION_VERSION_PATCH "2")

set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")

# SOVERSION scheme: CURRENT.AGE.REVISION
#   If there was an incompatible interface change:
#     Increment CURRENT. Set AGE and REVISION to 0
#   If there was a compatible interface change:
#     Increment AGE. Set REVISION to 0
#   If the source code was changed, but there were no interface changes:
#     Increment REVISION.
set(LIBRARY_VERSION "0.0.2")
set(LIBRARY_SOVERSION "0")

set(PAMTEST_LIBRARY_VERSION "0.0.2")
set(PAMTEST_LIBRARY_SOVERSION "0")

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefinePlatformDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(DefineOptions.cmake)
include(CPackConfig.cmake)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

find_package(PythonInterp)
set(Python_ADDITIONAL_VERSIONS 2.6 2.7 3.3 3.4)
find_package(PythonLibs)
find_package(PythonSiteLibs)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)
add_subdirectory(include)

if (UNIT_TESTING)
    find_package(CMocka REQUIRED)
    include(AddCMockaTest)
    add_subdirectory(tests)
endif (UNIT_TESTING)

# pkg-config file
get_filename_component(PAM_WRAPPER_LIB ${PAM_WRAPPER_LOCATION} NAME)

configure_file(pam_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper.pc
  DESTINATION
    ${LIB_INSTALL_DIR}/pkgconfig
  COMPONENT
    pkgconfig
)

configure_file(libpamtest.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libpamtest.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libpamtest.pc
  DESTINATION
    ${LIB_INSTALL_DIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
configure_file(pam_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config-version.cmake @ONLY)
configure_file(pam_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_DIR}/pam_wrapper
    COMPONENT
        devel
)

set(LIBPAMTEST_LIBRARY_NAME ${CMAKE_SHARED_LIBRARY_PREFIX}pamtest${CMAKE_SHARED_LIBRARY_SUFFIX})

configure_file(libpamtest-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/libpamtest-config.cmake @ONLY)
configure_file(libpamtest-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/libpamtest-config-version.cmake @ONLY)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/libpamtest-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/libpamtest-config-version.cmake
    DESTINATION
        ${CMAKE_INSTALL_DIR}/libpamtest
    COMPONENT
        devel
)

add_subdirectory(doc)

=== src/CMakeLists.txt ===
project(libpam_wrapper C)

include_directories(${CMAKE_BINARY_DIR})

###########################################################
### pam_wrapper
###########################################################

add_library(pam_wrapper SHARED pam_wrapper.c)

set(PAM_WRAPPER_LIBRARIES
	${PAMWRAP_REQUIRED_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT})
if (HAVE_OPENPAM)
	list(APPEND PAM_WRAPPER_LIBRARIES pam)
endif (HAVE_OPENPAM)

target_link_libraries(pam_wrapper ${PAM_WRAPPER_LIBRARIES} ${DLFCN_LIBRARY})

set_target_properties(
  pam_wrapper
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
)

install(
  TARGETS
    pam_wrapper
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

###########################################################
### libpamtest
###########################################################

set(pamtest_SOURCES
    libpamtest.c
)

set(pamtest_HEADERS
    ${CMAKE_SOURCE_DIR}/include/libpamtest.h
)
include_directories(${CMAKE_SOURCE_DIR}/include)

set(PAM_LIBRARIES pam)
if (HAVE_PAM_MISC)
	list(APPEND PAM_LIBRARIES pam_misc)
endif (HAVE_PAM_MISC)

add_library(pamtest SHARED
            ${pamtest_SOURCES}
            ${pamtest_HEADERS}
)
target_link_libraries(pamtest ${PAM_LIBRARIES})

set_target_properties(pamtest
    PROPERTIES
        VERSION ${LIBRARY_VERSION}
        SOVERSION ${LIBRARY_SOVERSION})

install(TARGETS pamtest
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR})

add_subdirectory(modules)
if (PYTHONLIBS_FOUND)
    add_subdirectory(python)
endif()

# This needs to be at the end
if (POLICY CMP0026)
    cmake_policy(SET CMP0026 OLD)
endif()
get_target_property(PAM_WRAPPER_LOCATION pam_wrapper LOCATION)
set(PAM_WRAPPER_LOCATION ${PAM_WRAPPER_LOCATION} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMOCKA_INCLUDE_DIR}
  ${CMAKE_SOURCE_DIR}/include
)

set(PAM_MATRIX_PATH "${CMAKE_BINARY_DIR}/src/modules/pam_matrix.so")

configure_file(services/matrix.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix @ONLY)

# Some tests use a passdb as argument for pam_matrix
set(PASSDB_RO_PATH ${CMAKE_CURRENT_BINARY_DIR}/passdb_ro)
configure_file(passdb_ro ${PASSDB_RO_PATH} @ONLY)
configure_file(services/matrix_opt.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix_opt @ONLY)

set(PASSDB_PY_PATH ${CMAKE_CURRENT_BINARY_DIR}/passdb_py)
configure_file(passdb_py ${PASSDB_PY_PATH} @ONLY)
configure_file(services/matrix_py.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix_py @ONLY)

configure_file(services/pwrap_get_set.in ${CMAKE_CURRENT_BINARY_DIR}/services/pwrap_get_set @ONLY)

if (OSX)
	set(TEST_ENVIRONMENT DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${PAM_WRAPPER_LOCATION};PAM_WRAPPER=1;PAM_WRAPPER_SERVICE_DIR=${CMAKE_CURRENT_BINARY_DIR}/services})
	add_definitions(-DOSX)
else ()
	set(TEST_ENVIRONMENT LD_PRELOAD=${PAM_WRAPPER_LOCATION};PAM_WRAPPER=1;PAM_WRAPPER_SERVICE_DIR=${CMAKE_CURRENT_BINARY_DIR}/services)
endif ()

set(PAM_LIBRARIES pam)
if (HAVE_PAM_MISC)
	list(APPEND PAM_LIBRARIES pam_misc)
endif (HAVE_PAM_MISC)

set(TEST_LIBRARIES
    pamtest
    ${CMOCKA_LIBRARY}
    ${PAM_LIBRARIES}
)

add_cmocka_test(test_pam_wrapper test_pam_wrapper.c ${TEST_LIBRARIES})
set_property(
    TEST
        test_pam_wrapper
    PROPERTY
        ENVIRONMENT ${TEST_ENVIRONMENT})

if (PYTHONLIBS_FOUND)
    add_test(pypamtest_test ${CMAKE_CURRENT_SOURCE_DIR}/pypamtest_test.py)
    set_property(
        TEST
            pypamtest_test
        PROPERTY
            ENVIRONMENT ${TEST_ENVIRONMENT})
endif()

=== src/python/CMakeLists.txt ===
project(pypamtest C)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${pam_wrapper-headers_DIR})
include_directories(${PYTHON_INCLUDE_DIR})

python_add_module(pypamtest pypamtest.c)
target_link_libraries(pypamtest pamtest ${PYTHON_LIBRARY})

install(
    TARGETS
        pypamtest
    DESTINATION
        ${CMAKE_INSTALL_PREFIX}/${PYTHON_SITELIB}
)

=== debian/changelog ===
pam-wrapper (1.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #825486)

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 27 May 2016 13:00:55 +0300

=== debian/control ===
Source: pam-wrapper
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper (>=9),
 cmake,
 libpam0g-dev,
Standards-Version: 3.9.8
Section: libs
Homepage: https://cwrap.org/pam_wrapper.html
Vcs-Git: https://anonscm.debian.org/pkg-sssd/pam-wrapper.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-sssd/pam-wrapper.git

Package: libpam-wrapper
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tool to test PAM applications and PAM modules
 This component of cwrap allows you to either test your PAM (Linux-PAM
 and OpenPAM) application or module.
 .
 For testing PAM applications, simple PAM module called pam_matrix is
 included. If you plan to test a PAM module you can use the pamtest library,
 which simplifies testing of modules. You can combine it with the cmocka
 unit testing framework or you can use the provided Python bindings to
 write tests for your module in Python.

## pam-wrapper 1.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 set(APPLICATION_VERSION_MAJOR "1")
 set(APPLICATION_VERSION_MINOR "0")
-set(APPLICATION_VERSION_PATCH "2")
+set(APPLICATION_VERSION_PATCH "6")
 
 set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
@@ -19,10 +19,10 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "0.0.2")
+set(LIBRARY_VERSION "0.0.3")
 set(LIBRARY_SOVERSION "0")
 
-set(PAMTEST_LIBRARY_VERSION "0.0.2")
+set(PAMTEST_LIBRARY_VERSION "0.0.3")
 set(PAMTEST_LIBRARY_SOVERSION "0")
 
 # where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
@@ -45,11 +45,6 @@
 # Find out if we have threading available
 set(CMAKE_THREAD_PREFER_PTHREADS ON)
 find_package(Threads)
-
-find_package(PythonInterp)
-set(Python_ADDITIONAL_VERSIONS 2.6 2.7 3.3 3.4)
-find_package(PythonLibs)
-find_package(PythonSiteLibs)
 
 # config.h checks
 include(ConfigureChecks.cmake)

=== src/python/python2/CMakeLists.txt ===
project(python2-pamtest C)

unset(PYTHON_EXECUTABLE CACHE)
unset(PYTHON_INCLUDE_DIR CACHE)
unset(PYTHON_LIBRARY CACHE)
unset(PYTHON_SITELIB CACHE)
unset(PYTHONLIBS_FOUND CACHE)
unset(PYTHONLIBS_VERSION_STRING CACHE)

set(Python_ADDITIONAL_VERSIONS 2.7 2.6)
find_package(PythonLibs)
find_package(PythonInterp)
find_package(PythonSiteLibs)

if (PYTHONLIBS_FOUND)
    set(PYTHON2_EXECUTABLE ${PYTHON_EXECUTABLE} CACHE FILEPATH "PYTHON2_EXECUTABLE")
    set(PYTHON2_INCLUDE_DIR ${PYTHON_INCLUDE_DIR})
    set(PYTHON2_LIBRARY ${PYTHON_LIBRARY})
    set(PYTHON2_SITELIB ${PYTHON_SITELIB})

    include_directories(${CMAKE_BINARY_DIR})
    include_directories(${pam_wrapper-headers_DIR})
    include_directories(${PYTHON2_INCLUDE_DIR})

    python_add_module(python2-pamtest ${pypamtest_SOURCE_DIR}/pypamtest.c)
    target_link_libraries(python2-pamtest pamtest ${PYTHON2_LIBRARY})
    set_target_properties(python2-pamtest PROPERTIES OUTPUT_NAME "pypamtest")

    install(TARGETS
                python2-pamtest
            DESTINATION
                ${CMAKE_INSTALL_PREFIX}/${PYTHON2_SITELIB})
endif()

=== src/python/python3/CMakeLists.txt ===
project(python3-pamtest C)

unset(PYTHON_EXECUTABLE CACHE)
unset(PYTHON_INCLUDE_DIR CACHE)
unset(PYTHON_LIBRARY CACHE)
unset(PYTHON_SITELIB CACHE)
unset(PYTHONLIBS_FOUND CACHE)
unset(PYTHONLIBS_VERSION_STRING CACHE)

set(Python_ADDITIONAL_VERSIONS 3.8 3.7 3.6)
find_package(PythonLibs)
find_package(PythonInterp)
find_package(PythonSiteLibs)

if (PYTHONLIBS_FOUND)
    set(PYTHON3_LIBRARY ${PYTHON_LIBRARY})
    set(PYTHON3_INCLUDE_DIR ${PYTHON_INCLUDE_DIR})
    set(PYTHON3_SITELIB ${PYTHON_SITELIB})
    set(PYTHON3_EXECUTABLE ${PYTHON_EXECUTABLE} CACHE FILEPATH "PYTHON3_EXECUTABLE")

    include_directories(${CMAKE_BINARY_DIR})
    include_directories(${pam_wrapper-headers_DIR})
    include_directories(${PYTHON3_INCLUDE_DIR})

    python_add_module(python3-pamtest ${pypamtest_SOURCE_DIR}/pypamtest.c)
    target_link_libraries(python3-pamtest pamtest ${PYTHON3_LIBRARY})
    set_target_properties(python3-pamtest PROPERTIES OUTPUT_NAME "pypamtest")

    install(TARGETS
                python3-pamtest
            DESTINATION
                ${CMAKE_INSTALL_PREFIX}/${PYTHON3_SITELIB})
endif()

=== debian/changelog ===
pam-wrapper (1.0.6-1) unstable; urgency=medium

  * New upstream release. (Closes: #894793)
  * Bump debhelper to 11, policy to 4.1.3, update VCS urls and
    maintainer address to SSSD team.
  * no-soname.diff: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 05 Apr 2018 11:30:52 +0300

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: pam-wrapper
 Priority: optional
-Maintainer: Timo Aaltonen <tjaalton@debian.org>
-Build-Depends: debhelper (>=9),
+Maintainer: Debian SSSD Team <pkg-sssd-devel@lists.alioth.debian.org>
+Uploaders: Timo Aaltonen <tjaalton@debian.org>
+Build-Depends: debhelper (>=11),
  cmake,
  libpam0g-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Section: libs
 Homepage: https://cwrap.org/pam_wrapper.html
-Vcs-Git: https://anonscm.debian.org/pkg-sssd/pam-wrapper.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-sssd/pam-wrapper.git
+Vcs-Git: https://salsa.debian.org/sssd-team/pam-wrapper.git
+Vcs-Browser: https://salsa.debian.org/sssd-team/pam-wrapper.git
 
 Package: libpam-wrapper
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --builddirectory=build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

## pam-wrapper 1.0.7

=== doc/CMakeLists.txt ===
install(FILES
            pam_wrapper.1
        DESTINATION
            ${MAN_INSTALL_DIR}/man1)

install(FILES
            pam_matrix.8
        DESTINATION
            ${MAN_INSTALL_DIR}/man8)

install(FILES
            pam_get_items.8
        DESTINATION
            ${MAN_INSTALL_DIR}/man8)

install(FILES
            pam_set_items.8
        DESTINATION
            ${MAN_INSTALL_DIR}/man8)

#
# Build the documentation
#
include(UseDoxygen OPTIONAL)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -47,11 +47,26 @@
     PROPERTY
         ENVIRONMENT ${TEST_ENVIRONMENT})
 
-if (PYTHONLIBS_FOUND)
-    add_test(pypamtest_test ${CMAKE_CURRENT_SOURCE_DIR}/pypamtest_test.py)
-    set_property(
-        TEST
-            pypamtest_test
-        PROPERTY
-            ENVIRONMENT ${TEST_ENVIRONMENT})
+if (PYTHON2_EXECUTABLE)
+    add_test(NAME
+                py2pamtest_test
+             COMMAND
+                ${PYTHON2_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pypamtest_test.py)
+
+    set_property(TEST
+                    py2pamtest_test
+                 PROPERTY
+                    ENVIRONMENT ${TEST_ENVIRONMENT})
 endif()
+
+if (PYTHON3_EXECUTABLE)
+    add_test(NAME
+                py3pamtest_test
+             COMMAND
+                ${PYTHON3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pypamtest_test.py)
+
+    set_property(TEST
+                    py3pamtest_test
+                 PROPERTY
+                    ENVIRONMENT ${TEST_ENVIRONMENT})
+endif()

=== src/modules/CMakeLists.txt ===
project(pam_wrapper-modules C)

set(PAM_MODULES pam_matrix pam_get_items pam_set_items)

set(PAM_LIBRARIES pam)
if (HAVE_PAM_MISC)
	list(APPEND PAM_LIBRARIES pam_misc)
endif (HAVE_PAM_MISC)

set(PWRAP_PRIVATE_LIBRARIES
	${LIB_INSTALL_DIR}/pam_wrapper)

foreach(_PAM_MODULE ${PAM_MODULES})
	add_library(${_PAM_MODULE} MODULE ${_PAM_MODULE}.c)
	set_property(TARGET ${_PAM_MODULE} PROPERTY PREFIX "")

	target_link_libraries(${_PAM_MODULE}
				${PAM_LIBRARIES})

	install(
		TARGETS
			${_PAM_MODULE}
		LIBRARY DESTINATION ${PWRAP_PRIVATE_LIBRARIES}
		ARCHIVE DESTINATION ${PWRAP_PRIVATE_LIBRARIES})
endforeach()

=== src/python/CMakeLists.txt ===
project(pypamtest C)

add_subdirectory(python2)
add_subdirectory(python3)

=== debian/changelog ===
pam-wrapper (1.0.7-1) unstable; urgency=medium

  * New upstream release. (Closes: #910642)
  * control: Add python bindings. (Closes: #898992)
  * no-soname.diff: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 10 Oct 2018 17:54:28 +0300

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,10 @@
 Build-Depends: debhelper (>=11),
  cmake,
  libpam0g-dev,
+ python-dev,
+ python3-dev,
+X-Python-Version: >= 2.7
+X-Python3-Version: >= 3.6
 Standards-Version: 4.1.3
 Section: libs
 Homepage: https://cwrap.org/pam_wrapper.html
@@ -23,3 +27,21 @@
  which simplifies testing of modules. You can combine it with the cmocka
  unit testing framework or you can use the provided Python bindings to
  write tests for your module in Python.
+
+Package: python-pypamtest
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
+Description: Tool to test PAM applications and PAM modules -- Python bindings
+ This component of cwrap allows you to either test your PAM (Linux-PAM
+ and OpenPAM) application or module.
+ .
+ This package includes bindings for Python 2.
+
+Package: python3-pypamtest
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
+Description: Tool to test PAM applications and PAM modules -- Python3 bindings
+ This component of cwrap allows you to either test your PAM (Linux-PAM
+ and OpenPAM) application or module.
+ .
+ This package includes bindings for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2,python3 --builddirectory=build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_missing:
	dh_missing --fail-missing

## pam-wrapper 1.1.3

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 3.5.0)
cmake_policy(SET CMP0048 NEW)

# Specify search path for CMake modules to be loaded by include()
# and find_package()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

# Add defaults for cmake
# Those need to be set before the project() call.
include(DefineCMakeDefaults)
include(DefineCompilerFlags)

project(pam_wrapper VERSION 1.1.3 LANGUAGES C)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# SOVERSION scheme: MAJOR.MINOR.PATCH
#   If there was an incompatible interface change:
#     Increment MAJOR. Set MINOR and PATCH to 0
#   If there was a compatible interface change:
#     Increment MINOR. Set PATCH to 0
#   If the source code was changed, but there were no interface changes:
#     Increment PATCH.
set(LIBRARY_VERSION_MAJOR 0)
set(LIBRARY_VERSION_MINOR 0)
set(LIBRARY_VERSION_PATCH 6)
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

set(PAMTEST_LIBRARY_VERSION_MAJOR 0)
set(PAMTEST_LIBRARY_VERSION_MINOR 0)
set(PAMTEST_LIBRARY_VERSION_PATCH 5)
set(PAMTEST_LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PAMTEST_LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

# add definitions
include(DefinePlatformDefaults)
include(GNUInstallDirs)
include(DefineOptions.cmake)
include(CPackConfig.cmake)
include(CompilerChecks.cmake)

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(include)
add_subdirectory(src)

if (UNIT_TESTING)
    find_package(CMocka 1.1.0 REQUIRED)
    include(AddCMockaTest)
    add_subdirectory(tests)
endif (UNIT_TESTING)

# Link compile database for clangd
execute_process(COMMAND cmake -E create_symlink
                "${CMAKE_BINARY_DIR}/compile_commands.json"
                "${CMAKE_SOURCE_DIR}/compile_commands.json")
# pkg-config file
get_filename_component(PAM_WRAPPER_LIB ${PAM_WRAPPER_LOCATION} NAME)

configure_file(pam_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper.pc
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

configure_file(libpamtest.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libpamtest.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libpamtest.pc
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
include(CMakePackageConfigHelpers)

write_basic_package_version_file(pam_wrapper-config-version.cmake
                                 COMPATIBILITY
                                     AnyNewerVersion)
configure_file(pam_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/pam_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/pam_wrapper
    COMPONENT
        devel
)

write_basic_package_version_file(pamtest-config-version.cmake
                                 COMPATIBILITY
                                     AnyNewerVersion)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pamtest-config-version.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pamtest
        COMPONENT devel)

add_subdirectory(doc)

=== debian/changelog ===
pam-wrapper (1.1.3-1~mx19) mx; urgency=medium

  * Rebuild for MX-19

 -- Timothy E. Harris <maintainer@mxrepo.com>  Wed, 20 Jan 2021 15:36:59 -0500

pam-wrapper (1.1.3-1) unstable; urgency=medium

  * New upstream release.
  * patches: Drop patches from previous upload, upstream.
  * no-soname.diff: Refreshed.
  * libpamtest0-dev.install: Updated.
  * Migrate to debhelper-compat, bump to 12.
  * control: Bump policy to 4.5.0.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 20 Oct 2020 12:24:49 +0300

pam-wrapper (1.0.7-4) unstable; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * d/p/modules-Add-pam_chatty-module.patch,
    d/p/python-Fix-crash-when-the-PAM-module-outputs-too-much-dat.patch,
    d/p/tests-Add-service-file-for-chatty-module.patch,
    d/p/tests-Add-test-for-verbose-PAM-modules.patch:
    - Import patchset to fix and test a crash when PAM module outputs
      too much data

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 24 Jan 2020 17:47:19 +0200

pam-wrapper (1.0.7-3) unstable; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * d/p/no-soname.diff: Only remove soname on wrapper (Closes: #949671)
  * Split libpam-wrapper package and libpamtest library
  * debian/control: build-depend on dh-python

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 23 Jan 2020 21:06:36 +0200

pam-wrapper (1.0.7-2) unstable; urgency=medium

  * Drop python2 support. (Closes: #937235)

 -- Timo Aaltonen <tjaalton@debian.org>  Sun, 08 Sep 2019 01:19:25 +0300

=== debian/control ===
Source: pam-wrapper
Priority: optional
Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
XSBC-Original-Maintainer: Debian SSSD Team <pkg-sssd-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (=12),
 cmake,
 libpam0g-dev,
 python3-dev,
 dh-python,
X-Python3-Version: >= 3.6
Standards-Version: 4.5.0
Section: libs
Homepage: https://cwrap.org/pam_wrapper.html
Vcs-Git: https://salsa.debian.org/sssd-team/pam-wrapper.git
Vcs-Browser: https://salsa.debian.org/sssd-team/pam-wrapper.git

Package: libpam-wrapper
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tool to test PAM applications
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 application.
 .
 For testing PAM applications, simple PAM module called pam_matrix is
 included.

Package: libpamtest0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libpam-wrapper (<< 1.0.7-3)
Breaks: libpam-wrapper (<< 1.0.7-3)
Description: Library to test PAM modules
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 module.
 .
 For testing a PAM module you can use the pamtest library, which simplifies
 testing of modules. You can combine it with the cmocka  unit testing framework
 or you can use the provided Python bindings to write tests for your module in
 Python.
 .
 This package provides shared libraries.

Package: libpamtest0-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
  libpamtest0 (= ${binary:Version}),
Replaces: libpam-wrapper (<< 1.0.7-3)
Breaks: libpam-wrapper (<< 1.0.7-3)
Description: Library to test PAM modules
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 module.
 .
 For testing a PAM module you can use the pamtest library, which simplifies
 testing of modules. You can combine it with the cmocka  unit testing framework
 or you can use the provided Python bindings to write tests for your module in
 Python.
 .
 This package provides development headers.

Package: python3-pypamtest
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
Description: Tool to test PAM applications and PAM modules -- Python3 bindings
 This component of cwrap allows you to either test your PAM (Linux-PAM
 and OpenPAM) application or module.
 .
 This package includes bindings for Python 3.

## pam-wrapper 1.1.4

=== doc/CMakeLists.txt ===
install(FILES
            pam_wrapper.1
        DESTINATION
            ${CMAKE_INSTALL_MANDIR}/man1)

install(FILES
            pam_matrix.8
        DESTINATION
            ${CMAKE_INSTALL_MANDIR}/man8)

install(FILES
            pam_chatty.8
        DESTINATION
            ${CMAKE_INSTALL_MANDIR}/man8)

install(FILES
            pam_get_items.8
        DESTINATION
            ${CMAKE_INSTALL_MANDIR}/man8)

install(FILES
            pam_set_items.8
        DESTINATION
            ${CMAKE_INSTALL_MANDIR}/man8)

#
# Build the documentation
#
include(UseDoxygen OPTIONAL)

=== src/python/CMakeLists.txt ===
project(pypamtest C)

add_subdirectory(python2)
add_subdirectory(python3)

if (WITH_WNO_CAST_FUNCTION_TYPE)
    set_source_files_properties(pypamtest.c
                                DIRECTORY python2 python3
                                PROPERTIES COMPILE_OPTIONS "-Wno-cast-function-type")
endif()

=== src/python/python2/CMakeLists.txt ===
project(python2-pamtest C)

if (NOT PYTHON2_LIBRARY)
    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_SITELIB CACHE)
    unset(PYTHONLIBS_FOUND CACHE)
    unset(PYTHONLIBS_VERSION_STRING CACHE)

    find_package(PythonLibs 2)
    find_package(PythonInterp 2)
    find_package(PythonSiteLibs 2)

    if (PYTHONLIBS_FOUND)
        set(PYTHON2_EXECUTABLE ${PYTHON_EXECUTABLE} CACHE FILEPATH "PYTHON2_EXECUTABLE")
        set(PYTHON2_INCLUDE_DIR ${PYTHON_INCLUDE_DIR})
        set(PYTHON2_LIBRARY ${PYTHON_LIBRARY})
        set(PYTHON2_SITELIB ${PYTHON_SITELIB})
    endif()

    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_SITELIB CACHE)
    unset(PYTHONLIBS_FOUND CACHE)
    unset(PYTHONLIBS_VERSION_STRING CACHE)
endif()

if (PYTHON2_INCLUDE_DIR AND PYTHON2_LIBRARY AND PYTHON2_SITELIB)
    include_directories(${CMAKE_BINARY_DIR})
    include_directories(${pam_wrapper-headers_DIR})
    include_directories(${PYTHON2_INCLUDE_DIR})

    python_add_module(python2-pamtest ${pypamtest_SOURCE_DIR}/pypamtest.c)
    target_link_libraries(python2-pamtest pamtest::pamtest ${PYTHON2_LIBRARY})
    target_compile_options(python2-pamtest
                           PRIVATE ${DEFAULT_C_COMPILE_FLAGS})
    set_target_properties(python2-pamtest PROPERTIES OUTPUT_NAME "pypamtest")

    install(TARGETS
                python2-pamtest
            DESTINATION
                ${CMAKE_INSTALL_PREFIX}/${PYTHON2_SITELIB})
endif()

=== debian/changelog ===
pam-wrapper (1.1.4-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:15:08 +0000

pam-wrapper (1.1.4-1) unstable; urgency=medium

  * New upstream release.
  * no-soname.diff: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 17 Nov 2021 20:47:17 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --with python2,python3 --builddirectory=build/
+	dh $@ --with python3 --builddirectory=build/
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

=== debian/watch ===
version=4
https://ftp.samba.org/pub/cwrap/ \
  pam_wrapper-([\d\.]+)\.tar\.gz

## pam-wrapper 1.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(pam_wrapper VERSION 1.1.3 LANGUAGES C)
+project(pam_wrapper VERSION 1.1.5 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -25,13 +25,13 @@
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
 set(LIBRARY_VERSION_MINOR 0)
-set(LIBRARY_VERSION_PATCH 6)
+set(LIBRARY_VERSION_PATCH 8)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})
 
-set(PAMTEST_LIBRARY_VERSION_MAJOR 0)
+set(PAMTEST_LIBRARY_VERSION_MAJOR 1)
 set(PAMTEST_LIBRARY_VERSION_MINOR 0)
-set(PAMTEST_LIBRARY_VERSION_PATCH 5)
+set(PAMTEST_LIBRARY_VERSION_PATCH 0)
 set(PAMTEST_LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PAMTEST_LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== src/python/python3/CMakeLists.txt ===
project(python3-pamtest C)

if (NOT PYTHON3_LIBRARY)
    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_SITELIB CACHE)
    unset(PYTHONLIBS_FOUND CACHE)
    unset(PYTHONLIBS_VERSION_STRING CACHE)

    find_package(PythonLibs 3)
    find_package(PythonInterp 3)
    find_package(PythonSiteLibs 3)

    if (PYTHONLIBS_FOUND)
        set(PYTHON3_LIBRARY ${PYTHON_LIBRARY})
        set(PYTHON3_INCLUDE_DIR ${PYTHON_INCLUDE_DIR})
        set(PYTHON3_SITELIB ${PYTHON_SITELIB})
        set(PYTHON3_EXECUTABLE ${PYTHON_EXECUTABLE} CACHE FILEPATH "PYTHON3_EXECUTABLE")
    endif()

    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_SITELIB CACHE)
    unset(PYTHONLIBS_FOUND CACHE)
    unset(PYTHONLIBS_VERSION_STRING CACHE)
endif()

if (PYTHON3_INCLUDE_DIR AND PYTHON3_LIBRARY AND PYTHON3_SITELIB)
    include_directories(${CMAKE_BINARY_DIR})
    include_directories(${pam_wrapper-headers_DIR})
    include_directories(${PYTHON3_INCLUDE_DIR})

    python_add_module(python3-pamtest ${pypamtest_SOURCE_DIR}/pypamtest.c)
    target_link_libraries(python3-pamtest pamtest::pamtest ${PYTHON3_LIBRARY})
    target_compile_options(python3-pamtest
                           PRIVATE ${DEFAULT_C_COMPILE_FLAGS})
    set_target_properties(python3-pamtest PROPERTIES OUTPUT_NAME "pypamtest")

    install(TARGETS
                python3-pamtest
            DESTINATION
                ${CMAKE_INSTALL_PREFIX}/${PYTHON3_SITELIB})
endif()

=== debian/changelog ===
pam-wrapper (1.1.5-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:14:58 +1100

pam-wrapper (1.1.5-1build2) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:14:36 +0100

pam-wrapper (1.1.5-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 20:37:41 +0000

pam-wrapper (1.1.5-1) unstable; urgency=medium

  * New upstream release.
  * Use Section:devel for consistency with other cwrap projects.

 -- Simon Josefsson <simon@josefsson.org>  Fri, 18 Aug 2023 13:53:22 +0200

pam-wrapper (1.1.4-3) unstable; urgency=medium

  * Fix --twice builds.  Closes: #1048879.
  * wrap-and-sort -satb.
  * tests: Add wrap-and-sort.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 16 Aug 2023 11:51:21 +0200

pam-wrapper (1.1.4-2) unstable; urgency=medium

  * control: Use new pkg-sssd email address.
  * control: Add myself as Uploaders.
  * control: Standards-Version 4.6.2.
  * control: Rules-Requires-Root: no.
  * upstream/metadata: Add.
  * upstream/signing-key.asc: Add.
  * watch: Add pgpsigurlmangle.  Use @ANY_VERSION@@ARCHIVE_EXT@.
  * copyright: Add myself for debian/*, silencing
    lintian warning update-debian-copyright.
  * Build with hardening=+all.
  * control: Fix Vcs-Browser URL.
  * Bump debhelper-compat to 13.
  * libpamtest0-dev: Improve Description.
  * control: Fix spurious white space in Description fields.
  * lintian-overrides: Fix syntax.  Drop unused libpamtest.so override.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 06 Aug 2023 09:26:33 +0200

=== debian/control ===
Source: pam-wrapper
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian SSSD Team <pkg-sssd-devel@alioth-lists.debian.net>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 libpam0g-dev,
 python3-dev,
X-Python3-Version: >= 3.6
Standards-Version: 4.6.2
Section: devel
Homepage: https://cwrap.org/pam_wrapper.html
Vcs-Git: https://salsa.debian.org/sssd-team/pam-wrapper.git
Vcs-Browser: https://salsa.debian.org/sssd-team/pam-wrapper
Rules-Requires-Root: no

Package: libpam-wrapper
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Tool to test PAM applications
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 application.
 .
 For testing PAM applications, simple PAM module called pam_matrix is
 included.

Package: libpamtest0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libpam-wrapper (<< 1.0.7-3),
Breaks:
 libpam-wrapper (<< 1.0.7-3),
Description: Library to test PAM modules
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 module.
 .
 For testing a PAM module you can use the pamtest library, which simplifies
 testing of modules. You can combine it with the cmocka unit testing framework
 or you can use the provided Python bindings to write tests for your module in
 Python.
 .
 This package provides shared libraries.

Package: libpamtest0-dev
Architecture: any
Multi-Arch: same
Depends:
 libpamtest0 (= ${binary:Version}),
 ${misc:Depends},
Replaces:
 libpam-wrapper (<< 1.0.7-3),
Breaks:
 libpam-wrapper (<< 1.0.7-3),
Description: Development files for library to test PAM modules
 This component of cwrap allows you to test your PAM (Linux-PAM and OpenPAM)
 module.
 .
 For testing a PAM module you can use the pamtest library, which simplifies
 testing of modules. You can combine it with the cmocka unit testing framework
 or you can use the provided Python bindings to write tests for your module in
 Python.
 .
 This package provides development headers.

Package: python3-pypamtest
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Tool to test PAM applications and PAM modules -- Python3 bindings
 This component of cwrap allows you to either test your PAM (Linux-PAM
 and OpenPAM) application or module.
 .
 This package includes bindings for Python 3.

=== debian/tests/control ===
Tests: wrap-and-sort
Depends:
 devscripts,
 python3-debian,
Restrictions: superficial

## pam-wrapper 1.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(pam_wrapper VERSION 1.1.5 LANGUAGES C)
+project(pam_wrapper VERSION 1.1.7 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -25,7 +25,7 @@
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
 set(LIBRARY_VERSION_MINOR 0)
-set(LIBRARY_VERSION_PATCH 8)
+set(LIBRARY_VERSION_PATCH 10)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== tests/CMakeLists.txt ===
project(tests C)

if (TARGET cmocka::cmocka)
    set(CMOCKA_LIBRARY cmocka::cmocka)
endif()

set(PAM_MATRIX_PATH "${CMAKE_BINARY_DIR}/src/modules/pam_matrix.so")

configure_file(services/matrix.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix @ONLY)

# Some tests use a passdb as argument for pam_matrix
set(PASSDB_RO_PATH ${CMAKE_CURRENT_BINARY_DIR}/passdb_ro)
configure_file(passdb_ro ${PASSDB_RO_PATH} @ONLY)
configure_file(services/matrix_opt.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix_opt @ONLY)

set(PASSDB_PY_PATH ${CMAKE_CURRENT_BINARY_DIR}/passdb_py)
configure_file(passdb_py ${PASSDB_PY_PATH} @ONLY)
configure_file(services/matrix_py.in ${CMAKE_CURRENT_BINARY_DIR}/services/matrix_py @ONLY)

configure_file(services/pwrap_get_set.in ${CMAKE_CURRENT_BINARY_DIR}/services/pwrap_get_set @ONLY)

set(PAM_CHATTY_PATH "${CMAKE_BINARY_DIR}/src/modules/pam_chatty.so")
configure_file(services/chatty.in ${CMAKE_CURRENT_BINARY_DIR}/services/chatty @ONLY)

function(ADD_CMOCKA_TEST_ENVIRONMENT _TEST_NAME)
    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
            find_library(ASAN_LIBRARY
                         NAMES asan)
            if (NOT ASAN_LIBRARY)
                foreach(version RANGE 10 1)
                    if (NOT ASAN_LIBRARY)
                        find_library(ASAN_LIBRARY libasan.so.${version})
                    endif()
                endforeach()
            endif()
        endif()
    endif()

    if (ASAN_LIBRARY)
        list(APPEND PRELOAD_LIBRARIES ${ASAN_LIBRARY})
    endif()
    list(APPEND PRELOAD_LIBRARIES ${PAM_WRAPPER_LOCATION})

    if (OSX)
        set(TORTURE_ENVIRONMENT "DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${RESOLV_WRAPPER_LOCATION}:${SOCKET_WRAPPER_LIBRARY}")
    else ()
        string(REPLACE ";" ":" _TMP_ENV "${PRELOAD_LIBRARIES}")
        set(TORTURE_ENVIRONMENT "LD_PRELOAD=${_TMP_ENV}")
    endif()

    list(APPEND TORTURE_ENVIRONMENT PAM_WRAPPER=1)
    list(APPEND TORTURE_ENVIRONMENT PAM_WRAPPER_SERVICE_DIR=${CMAKE_CURRENT_BINARY_DIR}/services)

    foreach(_arg ${ARGN})
        list(APPEND TORTURE_ENVIRONMENT ${_arg})
    endforeach()

    set_property(TEST
                    ${_TEST_NAME}
                PROPERTY
                    ENVIRONMENT "${TORTURE_ENVIRONMENT}")
endfunction()

set(PAM_LIBRARIES pam)
if (HAVE_PAM_MISC)
	list(APPEND PAM_LIBRARIES pam_misc)
endif (HAVE_PAM_MISC)

set(TEST_LIBRARIES
    pamtest
    ${CMOCKA_LIBRARY}
    ${PAM_LIBRARIES}
)

add_cmocka_test(test_pam_wrapper
                SOURCES test_pam_wrapper.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
                LINK_LIBRARIES ${TEST_LIBRARIES})
target_include_directories(test_pam_wrapper
                           PRIVATE
                               ${CMOCKA_INCLUDE_DIR}
                               ${pam_wrapper_BINARY_DIR})
add_cmocka_test_environment(test_pam_wrapper)

# Do not run python tests with AddressSanitizer
set(RUN_PYTHON_TESTS ON)
if (CMAKE_BUILD_TYPE)
    string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
    if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
        set(RUN_PYTHON_TESTS OFF)
    endif()
endif()

if (RUN_PYTHON_TESTS)
    find_package(Python 3.6 COMPONENTS Interpreter)
    if (Python_Interpreter_FOUND)
        add_test(NAME
                    py3pamtest_test
                 COMMAND
                    ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pypamtest_test.py)

        add_cmocka_test_environment(py3pamtest_test)
    endif()
endif()

=== src/modules/CMakeLists.txt ===
project(pam_wrapper-modules C)

set(PAM_MODULES pam_matrix pam_get_items pam_set_items pam_chatty)

set(PAM_LIBRARIES pam)
if (HAVE_PAM_MISC)
	list(APPEND PAM_LIBRARIES pam_misc)
endif (HAVE_PAM_MISC)

foreach(_PAM_MODULE ${PAM_MODULES})
	add_library(${_PAM_MODULE} MODULE ${_PAM_MODULE}.c)
    target_include_directories(${_PAM_MODULE}
                               PRIVATE
                                   ${pam_wrapper-headers_SOURCE_DIR}
                                   ${pam_wrapper_BINARY_DIR})
	set_property(TARGET ${_PAM_MODULE} PROPERTY PREFIX "")

	target_link_libraries(${_PAM_MODULE}
				${PAM_LIBRARIES})

	install(
		TARGETS
			${_PAM_MODULE}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/pam_wrapper
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}/pam_wrapper)
endforeach()

=== src/python/python3/CMakeLists.txt ===
project(python3-pamtest C)

find_package(Python 3.6 COMPONENTS Development Interpreter)
# Allow to specify sitearch dir on the commandline
if (NOT PYTHON_INSTALL_SITEARCH)
    set(PYTHON_INSTALL_SITEARCH ${Python_SITEARCH})
endif()

if (Python_Development_FOUND)
    add_library(python3-pamtest
                MODULE ${pypamtest_SOURCE_DIR}/pypamtest.c)
    target_compile_options(python3-pamtest
                           PRIVATE ${DEFAULT_C_COMPILE_FLAGS})
    target_include_directories(python3-pamtest
                               PRIVATE
                                   ${pam_wrapper_BINARY_DIR}
                                   ${pam_wrapper-headers_DIR})
    target_link_libraries(python3-pamtest PRIVATE pamtest::pamtest Python::Python)
    set_property(TARGET python3-pamtest PROPERTY PREFIX "")
    set_property(TARGET python3-pamtest PROPERTY OUTPUT_NAME "pypamtest")

    install(TARGETS
                python3-pamtest
            DESTINATION
                ${PYTHON_INSTALL_SITEARCH})
endif()

=== debian/changelog ===
pam-wrapper (1.1.7-1build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:04:22 +0100

pam-wrapper (1.1.7-1) unstable; urgency=medium

  [ Ben Hutchings ]
  * debian/salsa-ci.yml: Add local CI configuration
  * Replace wrap-and-sort autopkgtest with a CI job

  [ Simon Josefsson ]
  * New upstream release.
  * Standards-Version: 4.7.0.
  * Fix lintian update-debian-copyright.
  * Build-Depends on python3-setuptools.  Closes: #1080694.
  * Build python3-pypamtest reproducibly.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 23 Sep 2024 08:57:01 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python3 --builddirectory=build/

override_dh_clean:
	dh_clean
	rm -f compile_commands.json

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_missing:
	dh_missing --fail-missing
